<?php
/*---------------------------------------------------------------*/
/*
    Titre : Encadre une image                                                                                             
                                                                                                                          
    URL   : https://phpsources.net/code_s.php?id=986
    Date dition     : 15 Fv 2019                                                                                        
    Date mise  jour : 09 Oct 2019
                                                                                       
    Rapport de la maj:                                                                                                    
    - fonctionnement du code vérifié                                                                                    
*/
/*---------------------------------------------------------------*/

   function encadre($src , $format , $type){
   /* Paramètres : 
    * $src : nom de l'image a encadrer 
    * $format : format de la destination : GIF, JPG, PNG, WBMP 
    * $type : type de retour : 
    * FILE -> sauvegarde la destination sur le disque 
    * sous le nom passe en 4eme paramètre 
    * IMG -> envoie directement l'image au navigateur 
    */ 
    $size = getimagesize($src); 
    switch($size[2]) 
    { 
    case 1 : 
    if (imagetypes() & IMG_GIF) 
    $picsrc = imagecreatefromgif($src); 
    break; 
    case 2 : 
    if (imagetypes() & IMG_JPG) 
    $picsrc = imagecreatefromjpeg($src); 
    break; 
    case 3 : 
    if (imagetypes() & IMG_PNG) 
    $picsrc = imagecreatefrompng($src); 
    break; 
    default : 
    if (preg_match("/\.wbmp$/i", $src) && (imagetypes() & IMG_WBMP)) 
    $picsrc = imagecreatefromwbmp($src); 
    } 
    if (!$picsrc) 
    return FALSE; 
    
    $pic = imagecreate($size[0]+20, $size[1]+20); 
    $white = imagecolorallocate($pic, 255, 255, 255); 
    $black = imagecolorallocate($pic, 0, 0, 0); 
    $grey3 = imagecolorallocate($pic, 170, 170, 170); 
    $grey2 = imagecolorallocate($pic, 120, 120, 120); 
    $grey1 = imagecolorallocate($pic, 64, 64, 64); 
    
    imagefill($pic, 0, 0, $white); 
    imagecopy($pic, $picsrc, 10, 10, 0, 0, imagesx($picsrc), imagesy($picsrc)); 
    $x = imagesx($pic); 
    $y = imagesy($pic); 
    imagerectangle($pic, 0, 0, $x, $y, $black); 
    imagerectangle($pic, 1, 1, $x-1, $y-1, $grey1); 
    imagerectangle($pic, 2, 2, $x-2, $y-2, $grey2); 
    imagerectangle($pic, 3, 3, $x-3, $y-3, $grey3); 
    
    if (func_num_args() > 3) 
    $dest = func_get_arg(3); 
    else 
    $dest = "$src.cadre.$format"; 
    $format = strtoupper($format); 
    switch($format) 
    { 
    case "GIF" : 
    if (imagetypes() & IMG_GIF) 
    if(!strcasecmp($type, "FILE")) 
    imagegif($pic, $dest); 
    else 
    { 
    header("Content-Type: image/gif"); 
    imagegif($pic); 
    } 
    break; 
    case "JPG" : 
    if (imagetypes() & IMG_JPG) 
    if(!strcasecmp($type, "FILE")) 
    imagejpeg($pic, $dest); 
    else 
    { 
    header("Content-Type: image/jpg"); 
    imagejpeg($pic); 
    } 
    break; 
    case "PNG" : 
    if (imagetypes() & IMG_PNG) 
    if(!strcasecmp($type, "FILE")) 
    imagepng($pic, $dest); 
    else 
    { 
    header("Content-Type: image/png"); 
    imagepng($pic); 
    } 
    break; 
    case "WBMP" : 
    if (imagetypes() & IMG_WBMP) 
    if(!strcasecmp($type, "FILE")) 
    imagewbmp($pic, $dest); 
    else 
    { 
    header("Content-Type: image/wbmp"); 
    imagewbmp($pic); 
    } 
    break; 
    default : return FALSE; 
   }
  }
?>